datablock ParticleData(selectorParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 20;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.2 0.3 0.7";
	colors[1]     = "0.9 0.2 0.3 0.4";
	colors[2]     = "0.6 0.0 0.0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.2;
	sizes[2]      = 0.2;
	time[0]      = 0;
	time[1]      = 0.95;
	time[2]      = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(selectorEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.1;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "selectorParticle";
};
datablock ProjectileData(selectorProjectile : gunProjectile)
{
   projectileShapeName = "";
   directDamage        = 0;
   directDamageType    = "";
   radiusDamageType    = "";

   brickExplosionImpact = false;
   brickExplosionForce  = 0;

   explosion="";
   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   particleEmitter     = "selectorEmitter"; //bulletTrailEmitter;

   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 200;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};
datablock ShapeBaseImageData(selectorImage)
{
   shapeFile = "base/data/shapes/printGun.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.7 1.2 -0.55"; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   showBricks = 1;

   correctMuzzleVector = true;

   className = "WeaponImage";

   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.8 0.5 0.65 1.0";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Exit";
	stateTimeoutValue[2]            = 0.01;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;

	stateName[3] = "Exit";
	stateFire[3]                    = true;
	stateTransitionOnTriggerDown[3]  = "Fire";
	stateTransitionOnTriggerUp[3]  = "Ready";
};

function selectorImage::onFire(%this,%obj,%slot)
{	
	%client=%obj.client;
	if(%client.bricksWaiting>0 || (((getSimTime()/1000)-%this.lastFireTime)<0.2 && %client.selectSize>0 && %this.lastFireTime!=0))
		return;
	%this.lastFireTime=getSimTime()/1000;
	%vector=%obj.getMuzzleVector(0);
	%point=%obj.getMuzzlePoint(0);
	new Projectile()
	{
		dataBlock="selectorProjectile";
		initialPosition=vectorAdd(%point,%vector);
		initialVelocity=vectorScale(vectorAdd(%obj.getEyeVector(),%vector),100);
	};
	%range=vectorAdd(%point,vectorScale(%vector,30));
	%ray=containerRaycast(%point,%range,$TypeMasks::fxBrickAlwaysObjectType);
	%col=getWord(%ray,0);
	if(!isObject(%col))
		return;
	if(getBrickGroupFromObject(%col).Trust[%client.bl_id]!=2 && %client.bl_id!=getBrickGroupFromObject(%col).bl_id)
	{
		%client.centerPrint((getBrickGroupFromObject(%col).name$="" ? "\c1BL_ID: "@ getBrickGroupFromObject(%col).bl_id : getBrickGroupFromObject(%col).name) SPC "\c0does not trust you enough to do that.",2);
		return;
	}
	if(%client.selectionFilter$="Color")
		%client.selectionFilterRef=(!isObject(%col.selected) ? %col.colorID : (%col.oldColor$="" ? %col.colorID : firstWord(%col.oldColor)));
	else if(%client.selectionFilter$="Ownership")
		%client.selectionFilterRef=%col.stackBL_ID;
	else if(%client.selectionFilter$="Brick-Type")
		%client.selectionFilterRef=%col.dataBlock;
	else if(%client.selectionFilter$="Print")
		%client.selectionFilterRef=%col.printID;
	else if(%client.selectionFilter$="Wrench-Settings")
		%client.selectionFilterRef=%col.getName() @ %col.light @ %col.emitter @ %col.item @ %col.isRayCasting() @ %col.isColliding() @ %col.isRendering();
	else if(%client.selectionFilter$="X-Coordinate")
		%client.selectionFilterRef=firstWord(%col.position);
	else if(%client.selectionFilter$="Y-Coordinate")
		%client.selectionFilterRef=getWord(%col.position,1);
	else if(%client.selectionFilter$="Z-Coordinate")
		%client.selectionFilterRef=getWord(%col.position,2);
	else
		%client.selectionFilterRef="IGNORE";
	if(%client.selectSize==0 || %client.selectMode==2)
	{
		switch(%client.selectMode)
		{
		case 0:
			if(SLCT_filterSelection(%client,%col)==true && isObject(%col.selected))
			{
				%client.selectionLast.clear();
				SLCT_subSelection(%client,%col,1);
			}
		case 1:
			if(SLCT_filterSelection(%client,%col)==true && %col.selected$="")
			{
				%client.selectionLast.clear();
				SLCT_addSelection(%client,%col,1);
			}
		case 2:
			manageProperties(%client,%col,1);
		}
	}
	else
	{
		%client.selectionLast.clear();
		InitContainerRadiusSearch(%col.position,%client.selectSize,$typeMasks::fxBrickAlwaysObjectType);
		while((%next=containerSearchNext())!=0 && (%client.selectMode==0 ? true : (%client.SLCTGroup.getCount()+%client.bricksWaiting)<$Pref::Server::SLCTHardLimit))
		{
			%test=SLCT_filterSelection(%client,%next) && %client.selecting!=2;
			if(%client.selectMode==0 && %test && isObject(%next.selected))
			{
				%client.bricksWaiting=%client.bricksWaiting+1;
				schedule((%client.bricksWaiting/(%client.isAdmin==0 ? $Pref::Server::SLCTWaitTime : $Pref::Server::SLCTWaitTime::Admin))*(%client.bricksWaiting/10),0,"SLCT_subSelection",%client,%next);
			}
			else if(%client.selectMode==1 && %test && %next.selected$="")
			{
				%client.bricksWaiting=%client.bricksWaiting+1;
				schedule((%client.bricksWaiting/(%client.isAdmin==0 ? $Pref::Server::SLCTWaitTime : $Pref::Server::SLCTWaitTime::Admin))*(%client.bricksWaiting/10),0,"SLCT_addSelection",%client,%next);
			}
		}
	}
}

function selectorImage::onMount(%this,%obj,%slot)
{
	%client=%obj.client;
	if(isObject(%client.minigame))
		if(%client.minigame.enableBuilding==0)
			return;
	if($Pref::Server::SLCTAdminOnly==1 && %client.isAdmin==0)
		return;
	if(!isObject(%client.SLCTGroup))
		%client.SLCTGroup=new SimSet();
	if(!isObject(%client.selectionLast))
		%client.selectionLast=new SimSet();
	if(%client.SLCTGroup.getCount()==0 && %client.brickWaiting==0)
			%client.selectMode=1;
	serverCmdCancelBrick(%client);
	%obj.playThread(0,armReadyRight);
	selectorInfoLoop(%client);
	%client.selectSize=(%client.selectSize$="NULL" ? 0 : %client.selectSize);
	%client.selecting=true;
	%client.lastSelectMode=0;
	Parent::onMount(%this,%obj,%slot);
}

function selectorImage::onUnMount(%this,%obj,%slot)
{	
	%client=%obj.client;
	if(!isObject(%client))
		return;
	%client.selecting=false;
	if(%client.selectorTools==false)
		forSelected(%client,1);
	Parent::onUnMount(%this,%obj,%slot);
}

function checkImage(%obj)
{
	if(!isObject(%obj.getMountedImage(0)))
	{
		%obj.playThread(0,root);
		return;
	}
	if(%obj.getMountedImage(0).armReady==0)
		%obj.playThread(0,root);
}

//Duplicator Support:
//due to packaging conflicts, this is the way we have to do it.
datablock shapeBaseImageData(duplicatorCopycatImage : duplicatorImage)
{
	item                            = "";
	projectile                      = "";
	stateAllowImageChange[2]        = "0";
	stateEmitter[1]                 = "duplicatorEmitterA";
	stateEmitter[3]                 = "duplicatorEmitterB";
	stateEmitterNode[1]             = "muzzlePoint";
	stateEmitterNode[3]             = "blah";
	stateEmitterTime[1]             = "0.15";
	stateEmitterTime[3]             = "0.4";
	stateFire[3]                    = "1";
	stateName[0]                    = "Activate";
	stateName[1]                    = "Ready";
	stateName[2]                    = "PreFire";
	stateName[3]                    = "Fire";
	stateName[4]                    = "CheckFire";
	stateName[5]                    = "StopFire";
	stateScript[2]                  = "onPreFire";
	stateScript[3]                  = "onFire";
	stateScript[5]                  = "onStopFire";
	stateSequence[3]                = "fire";
	stateSequence[5]                = "StopFire";
	stateTimeoutValue[2]            = "0.1";
	stateTimeoutValue[3]            = "0.2";
	stateTimeoutValue[5]            = "0.2";
	stateTransitionOnTimeout[0]     = "ready";
	stateTransitionOnTimeout[1]     = "ready";
	stateTransitionOnTimeout[2]     = "fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTransitionOnTimeout[5]     = "ready";
	stateTransitionOnTriggerDown[1] = "PreFire";
	stateTransitionOnTriggerDown[4] = "fire";
	stateTransitionOnTriggerUp[4]   = "StopFire";
};

function duplicatorCopycatImage::onFire(%this,%obj,%slot)
{
	%client=%obj.client;
	if(%obj.getDamagePercent()<1.0)
		%obj.playThread(2, shiftAway);
	if(%client.selectorTools==true && $Duplicator::Msg::TimeOut!$="" && !isObject(%client.dupObj))
	{
		if($Duplicator::HighlightColor $= "")
		{
			determineBrightestColor();
		}
		if($Sim::Time < %client.dupTimeoutA)
		{
			messageClient(%client, 'MsgPlantError_Flood');
			%client.dupMsg($Duplicator::Msg::Timeout, "duplicate", mCeil(%client.dupTimeoutA - $Sim::Time));
			return;
		}
		if(%client.isAdmin || %client.isSuperAdmin)
		{
			%timeout = $Pref::Duplicator::TimeoutA::Admin;
			%client.SLCTDuplicatorMaxBricks = $Pref::Duplicator::MaxBricks::Admin;
		}
		else
		{
			if($Pref::Duplicator::AdminOnly)
			{
				%client.dupMsg($Duplicator::Msg::AdminOnly);
				return;
			}
			%timeout = $Pref::Duplicator::TimeoutA::NonAdmin;
			%client.SLCTDuplicatorMaxBricks = $Pref::Duplicator::MaxBricks::NonAdmin;
		}
		%ref=%client.SLCTGroup.getObject(0);
		for(%x=1;%x<%client.SLCTGroup.getCount();%x++)
		{
			%brick=%client.SLCTGroup.getObject(%x);
			if(getWord(%ref.position,2)>getWord(%brick.position,2))
				%ref=%brick;
		}
		%client.SLCTDuplicatorStartPos=%ref.position;
		forSelected(%client,6);
		if(%client.dupObj.bricks>0)
		{
			if(isObject(%client.player.tempBrick))
				%client.player.tempBrick.delete();
			bottomPrint(%client, "<color:FF8888>Duplication<color:FF0000> Mode" NL %client.dupObj.bricks @ " Brick" @ (%client.dupObj.bricks == 1 ? "" : "s") @ " Selected", 0, 3);
			%client.player.tempBrick = new fxDtsBrick()
			{
				position      = %ref.position;
				rotation      = %ref.rotation;
				dataBlock     = %ref.dataBlock;
				angleId       = %ref.angleId;
				colorId       = firstWord(%ref.oldColor);
				printId       = %ref.printId;
				client        = %client;
				dupStartBrick = 1;
			};
			%client.dupTimeoutA = $Sim::Time+%timeout;
		}
	}
}