if(isFile("Add-Ons/Tool_Duplicator/server.cs"))
	exec("Add-Ons/Tool_Duplicator/server.cs");
	
exec("./selector.cs");

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$Selector::PrefsSet)
	{
		RTB_registerPref("Admin Only", "Selector", "Pref::Server::SLCTAdminOnly", "bool", "Tool_Selector", 0, 0, 0);
		RTB_registerPref("Max Bricks (Admin)", "Selector", "Pref::Server::SLCTHardLimit::Admin", "int 0 200000", "Tool_Selector", 50000, 0, 0);
		RTB_registerPref("Max Bricks (Non-Admin)", "Selector", "Pref::Server::SLCTHardLimit", "int 0 200000", "Tool_Selector", 2500, 0, 0);
		RTB_registerPref("Speed Factor (Admin)", "Selector", "Pref::Server::SLCTWaitTime::Admin", "int 0 100", "Tool_Selector", 40, 0, 0);
		RTB_registerPref("Speed Factor (Non-Admin)", "Selector", "Pref::Server::SLCTWaitTime", "int 0 100", "Tool_Selector", 10, 0, 0);
		RTB_registerPref("Selected ColorFX", "Selector", "Pref::Server::SLCTEffectFX", "int 0 6", "Tool_Selector", 4, 0, 0);
		RTB_registerPref("Selected Color", "Selector", "Pref::Server::SLCTEffectColor", "int 0 64", "Tool_Selector", 1, 0, 0);
		$Selector::PrefsSet = 1;
	}
}
else //if you do not have RTB, you can change the preferences here:
{
	$Pref::Server::SLCTEffectFX=4; //default: 4
	$Pref::Server::SLCTEffectColor=1; //default: 1
	$Pref::Server::SLCTAdminOnly=0; //default: 0
	$Pref::Server::SLCTWaitTime=10; //Wait time for non-admins (higher is quicker) - default: 10
	$Pref::Server::SLCTWaitTime::Admin=40; //Admin - default: 40 (zero is quickest)
	$Pref::Server::SLCTHardLimit=2500; //default: 2500
	$Pref::Server::SLCTHardLimit::Admin=50000; //Admin - default: 50000
}

package selectorTools
{
	function GameConnection::onClientLeaveGame(%this)
	{
		SLCTGroup_clear(%this.SLCTGroup,1);
		SLCTGroup_clear(%this.selectionLast,1);
		Parent::onClientLeaveGame(%this);
	}
	function serverCmdTrust_Demote(%client,%targetID,%level)
	{
		Parent::serverCmdTrust_Demote(%client,%targetID,%level);
		if(%level<2)
		{
			%target=findClientByBL_ID(%targetID);
			if(isObject(%client.SLCTGroup))
				pruneBadSelectionBricks(%client);
			if(isObject(%target.SLCTGroup))
				pruneBadSelectionBricks(%target);
		}
	}
	function serverCmdLight(%client)
	{
		if(%client.selecting==0 || %client.bricksWaiting>0)
		{
			Parent::serverCmdLight(%client);
			return;
		}
		if(%client.selectMode==2)
			%client.selectMode=1;
		else
			%client.selectMode=(%client.selectMode>=1 ? 0 : (%client.selectMode>1 ? 0 : 1));
		serverPlay3D(playerMountSound,%client.player.position);
		%client.centerPrint("\c5Selector\c6 changed to\c3 " @ (%client.selectMode==1 ? "Addition" : "Subtraction") @ " \c6mode.",4);
	}
	function serverCmdCancelBrick(%client)
	{
		if(%client.selecting==0 && %client.selectorTools==0 || !isObject(%client.SLCTGroup))
		{
			Parent::serverCmdCancelBrick(%client);
			return;
		}
		if(%client.selectorTools==true)
		{
			%client.centerPrint("",0.01);
			serverCmdSelector(%client,"null","~");
		}
		if(%client.SLCTGroup.getCount()>0 || %client.selectorTools==true)
			forSelected(%client,1);
	}
	function serverCmdUndoBrick(%client)
	{
		if(%client.selecting==1 && %client.bricksWaiting==0)
		{
			for(%i=0;%i<(%client.selectionLast.getCount());%i++)
			{
				%brick=%client.selectionLast.getObject(%i);
				if(%client.SLCTGroup.isMember(%brick))
					schedule((%client.bricksWaiting/(%client.isAdmin==0 ? $Pref::Server::SLCTWaitTime : $Pref::Server::SLCTWaitTime::Admin))*(%client.bricksWaiting/10),0,"SLCT_subSelection",%client,%brick);
				else
					schedule((%client.bricksWaiting/(%client.isAdmin==0 ? $Pref::Server::SLCTWaitTime : $Pref::Server::SLCTWaitTime::Admin))*(%client.bricksWaiting/10),0,"SLCT_addSelection",%client,%brick);
			}
		}
		else
			Parent::serverCmdUndoBrick(%client);
	}
	function serverCmdUseSprayCan(%client,%last)
	{
		if(%client.selectorTools==true)
		{
			%client.centerPrint("\c3Selection \c2Paint\c6 mode:\n\c6Click to paint selected bricks.");
			if(%client.selectorPainting==false)
			{
				%client.selectorPainting=true;
				%client.lastPaintType=0;
				forSelected(%client,2);
				%client.lastPaintColor=0;
				%client.lastPaintType=1;
				forSelected(%client,2);
			}
		}
		Parent::serverCmdUseSprayCan(%client,%last);
		%client.lastPaintColor=%last;
		%client.lastPaintType=0;
	}
	function serverCmdUseFXCan(%client,%last)
	{
		if(%client.selectorTools==true)
		{
			%client.centerPrint(%last==8 ? "\c3Selection \c2Shape FX\c6 mode:\n\c6Click to paint selected bricks undulo or water fx." : "\c3Selection \c2Paint FX\c6 mode:\n\c6Click to paint selected bricks.");
			if(%client.selectorPainting==false)
			{
				%client.selectorPainting=true;
				%client.lastPaintType=0;
				forSelected(%client,2);
				%client.lastPaintColor=0;
				%client.lastPaintType=1;
				forSelected(%client,2);
			}
		}
		Parent::serverCmdUseFXCan(%client,%last);
		%client.lastPaintColor=%last;
		%client.lastPaintType=1;
	}
	function wrenchImage::onFire(%this,%obj,%slot)
	{
		if(%obj.client.selectorTools==true)
		{
			serverPlay3D(wrenchHitSound,%obj.position);
			commandToClient(%obj.client,'openWrenchDlg',"For All Selected Bricks",1,0,0);
		}
		else
			Parent::onFire(%this,%obj,%slot);
	}
	function serverCmdSetWrenchData(%client,%settings)
	{
		if(%client.selectorTools==false)
			Parent::serverCmdSetWrenchData(%client,%settings);
		else
		{
			for(%x=0;%x<(%client.SLCTGroup.getCount());%x++)
			{
				%client.wrenchBrick=%client.SLCTGroup.getObject(%x);
				Parent::serverCmdSetWrenchData(%client,%settings);
				%client.wrenchBrick.oldColor=setWord(%client.wrenchBrick.oldColor,2,%client.wrenchBrick.isRendering());
			}
		}
	}
	function serverCmdClearEvents(%client)
	{
		if(%client.selectorTools==false)
			Parent::serverCmdClearEvents(%client);
		else
			for(%x=0;%x<(%client.SLCTGroup.getCount());%x++)
			{
				%client.wrenchBrick=%client.SLCTGroup.getObject(%x);
				Parent::serverCmdClearEvents(%client);
			}
	}
	function serverCmdAddEvent(%client,%a,%b,%c,%d,%e,%f,%g,%h,%i,%j)
	{
		if(%client.selectorTools==false)
			Parent::serverCmdAddEvent(%client,%a,%b,%c,%d,%e,%f,%g,%h,%i,%j);
		else
		{
			for(%x=0;%x<(%client.SLCTGroup.getCount());%x++)
			{
				%client.wrenchBrick=%client.SLCTGroup.getObject(%x);
				Parent::serverCmdAddEvent(%client,%a,%b,%c,%d,%e,%f,%g,%h,%i,%j);
			}
		}
	}
	function hammerImage::onFire(%this,%obj,%slot)
	{
		if(%obj.client.selectorTools==true)
		{
			forSelected(%obj.client,5);
			pruneBadSelectionBricks(%obj.client);
		}
		else
			Parent::onFire(%this,%obj,%slot);
	}
	function wandImage::onFire(%this,%obj,%slot)
	{
		if(%obj.client.selectorTools==true)
		{
			forSelected(%obj.client,3);
			pruneBadSelectionBricks(%obj.client);
		}
		else
			Parent::onFire(%this,%obj,%slot);
	}
	function printGunImage::onFire(%this,%obj,%slot)
	{
		if(%obj.client.selectorTools==true)
			commandToClient(%obj.client,'openPrintSelectorDlg',"2x2f",0,0);
		else
			Parent::onFire(%this,%obj,%slot);
	}
	function serverCmdSetPrint(%client,%id)
	{
		if(%client.selectorTools==false)
			Parent::serverCmdSetPrint(%client,%id);
		else
		{
			%count=%client.SLCTGroup.getCount();
			for(%i=0;%i<%count;%i++)
			{
				%brick=%client.SLCTGroup.getObject(%i);
				%brick.setPrint(%id);
			}
		}
	}
 	function weaponImage::onFire(%this,%obj,%slot) //This only works for paint-can and brick-gun
	{
		%name=%this.getName();
		%time=(getSimTime()/1000);
		if(%obj.client.selectorPainting==true)
		{
			if(%this.Item$="sprayCan" && %name!$="printGunImage" && (%time-%obj.client.lastPaintTime)>0.2)
			{
				if(%obj.client.lastPaintType==1 && %obj.client.lastPaintColor>=8)
					%obj.client.lastPaintColor=(%obj.client.lastPaintColor==8 ? 9 : 8);
				forSelected(%obj.client,2);
				%obj.client.lastPaintTime=%time;
				return;
			}
		}
		if(%obj.client.selectorTools==false)
		{
			Parent::onFire(%this,%obj,%slot);
			return;
		}
	}
	function weaponImage::onUnMount(%this,%obj,%slot)
	{
		Parent::onUnMount(%this,%obj,%slot);
		schedule(100,0,"checkImage",%obj);
	}
	function weaponImage::onMount(%this,%obj,%slot)
	{
		Parent::onMount(%this,%obj,%slot);
		schedule(100,0,"checkImage",%obj);
		if(%obj.client.selectorPainting==true && (%this.Item!$="sprayCan" || %this.getName()$="printGunImage"))
		{
			%obj.client.selectorPainting=false;
			for(%i=0;%i<(%obj.client.SLCTGroup.getCount());%i++)
			{
				%brick=%obj.client.SLCTGroup.getObject(%i);
				%brick.setColor($Pref::Server::SLCTEffectColor);
				%brick.setColorFX($Pref::Server::SLCTEffectFX);
			}
		}
		if(%obj.client.selectorTools==true)
		{
			switch$(%this.getName())
			{
				case "hammerImage":
					%x="\c3Selection \c2Safe Kill\c6 mode:\n\c6Click to hammer all selected bricks.";
				case "wandImage":
					%x="\c3Selection \c2Kill\c6 mode:\n\c6Click to kill all selected bricks.";
				case "wrenchImage":
					%x="\c3Selection \c2Wrench\c6 mode:\n\c6Click to change selected bricks' settings.";
				case "printGunImage":
					%x="\c3Selection \c2Print\c6 mode:\n\c6Click to change selected bricks' prints.";
				case "duplicatorImage":
					%x="\c3Selection \c2Duplication\c6 mode:\n\c6Click to duplicate selected bricks.";
					%doSwitch=true;
				case "duplicatorCopycatImage":
					%x="\c3Selection \c2Duplication\c6 mode:\n\c6Click to duplicate selected bricks.";
				default:
					if(%this.Item!$="sprayCan" || %this.getName()$="printGunImage")
					{
						%cond=true;
						%obj.client.centerPrint("");
						%obj.client.bottomPrint("",0.01);
						%obj.client.selectorTools=false;
						%obj.client.selectorPainting=false;
					}
			}
			if(%cond==false)
				%obj.client.bottomPrint("<just:center>\c6Use the \c3cancel brick placement key\c0 (default: numpad 0)\c6 to exit.");
		}
		if(%obj.client.selectorTools==true && (%this.Item!$="sprayCan" || %this.getName()$="printGunImage"))
		{
			%obj.client.centerPrint(%x);
			if(%doSwitch==true)
				%obj.mountImage("duplicatorCopycatImage",0);
		}
	}
};
activatePackage("selectorTools");

// Select group functions

function SLCT(%group,%operation)
{
	if(!isObject(%group))
		return;
	if(%group.getCount()>0)
	{
		for(%x=0;%x<(%group.getCount());%x++)
		{
			%brick=%group.getObject(%x);
			if(isObject(%brick))
				call(%brick @ "." @ %operation);
		}
	}
}

function SLCTGroup_clear(%group,%opt)
{
	SLCT(%group,"setColor(firstWord(%brick.oldColor))");
	SLCT(%group,"setColorFX(getWord(%brick.oldColor,1))");
	SLCT(%group,"selected=-1");
	if(%opt==1 && isObject(%group))
		%group.delete();
}

// Main functions

function selectorInfoLoop(%client)
{
	%brickCount=(!isObject(%client.SLCTGroup) ? 0 : %client.SLCTGroup.getCount());
	if(%client.brickswaiting>0)
	{
		%x=getRandom(0,90);
		%client.centerPrint("<just:center>" @ (%client.selecting==2 ? ("<font:times:30>\c6Canceling...") : ((%client.selectMode==0 ? "<font:times:30>De-" : "") @ "<font:times:30>\c6Selecting..." NL "<font:impact:25>\c6" @ %brickCount @ "\c7/\c0" @ (%client.selectMode==0 ? ("-" @ %client.bricksWaiting) : (%client.bricksWaiting+%brickCount)) @ "\n<font:times:16>\c3\"/selector cancel\" to stop selection")),1);
	}
	%mode=(%client.selectMode==0 ? "Subtraction" : (%client.selectMode==1 ? "Addition" : "Copy"));
	%x=(%client.selectMode==0 ? "" : (%client.selectMode==1 ? "   " : "       "));
	%size=(%client.selectMode==2 ? "0 (temp)" : (%client.selectSize$="" ? 0 : %client.selectSize));
	%client.bottomPrint("\c2Selector Settings:\n<just:left>\c3Mode: \c6" @ %mode @ %x @ "   \c3Filter: \c6" @ (%client.selectionFilter$="" ? "None" : %client.selectionFilter) @ "<just:right>\c3Size: \c6" @ %size @ "   \c3Selected Count: \c6" @ %brickCount NL "<just:left>  <font:times:16><color:acacac>(use light to change)",1);
	schedule(750,0,"selectorInfoLoopOut",%client);
}

function selectorInfoLoopOut(%client)
{ 
	if(%client.selecting>=1 || %client.brickswaiting>0)
		selectorInfoLoop(%client);
}

function removeFromSLCT(%client,%brick)
{
	if(!isObject(%client.SLCTGroup) || %client.SLCTGroup.isMember(%brick)==false)
		return;
	if(isObject(%brick))
	{
		%brick.setColor(firstWord(%brick.oldColor));
		%brick.setColorFX(getWord(%brick.oldColor,1));
		%brick.setRendering(getWord(%brick.oldColor,2));
		%brick.selected="";
		%client.SLCTgroup.remove(%brick);
	}
}

function pruneBadSelectionBricks(%client)
{
	if(!isObject(%client.SLCTGroup))
		return;
	%count=%client.SLCTGroup.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%brick=%client.SLCTGroup.getObject(%i);
		%trust=(getBrickGroupFromObject(%brick).Trust[%client.bl_id]==2 || %client.bl_id==getBrickGroupFromObject(%brick).bl_id);
		if(%trust==false)
			schedule(20,0,"removeFromSLCT",%client,%brick);
	}
}

function SLCT_filterSelection(%client,%brick)
{
	if(getBrickGroupFromObject(%brick).isPublicDomain==1)
		%cond=true;
	else
		%cond=(getBrickGroupFromObject(%brick).Trust[%client.bl_id]==2 || %client.bl_id==getBrickGroupFromObject(%brick).bl_id);
	if(%cond==false && %brick.selected!=%client)
	{
		return(false);
	}
	%mode=((%client.selectMode==1 && %brick.selected$="") || (%client.selectMode==0 && isObject(%brick.selected)));
	if(!isObject(%brick) || %mode==false || %client.SLCTGroup.getCount()>=(%client.isAdmin==0 ? $Pref::Server::SLCTHardLimit : $Pref::Server::SLCTHardLimit::Admin))
	{
		return(false);
	}
	if(%client.selectionFilterRef$="IGNORE")
		return(true);
	else if(%client.selectionFilter$="Color" && (isObject(%brick.selected) ? firstWord(%brick.oldColor) : %brick.colorID)==%client.selectionFilterRef)
		return(true);
	else if(%client.selectionFilter$="Ownership" && %brick.stackBL_ID==%client.selectionFilterRef)
		return(true);
	else if(%client.selectionFilter$="Brick-Type" && %brick.dataBlock$=%client.selectionFilterRef)
		return(true);
	else if(%client.selectionFilter$="Print" && %brick.printID$=%client.selectionFilterRef)
		return(true);
	else if(%client.selectionFilter$="Wrench-Settings")
	{
		%compare=%brick.getName() @ %brick.light @ %brick.emitter @ %brick.item @ %brick.isRayCasting() @ %brick.isColliding() @ %brick.isRendering();
		if(%compare$=%client.selectionFilterRef)
			return(true);
	}
	else if(%client.selectionFilter$="X-Coordinate" && firstWord(%brick.position)==%client.selectionFilterRef)
		return(true);
	else if(%client.selectionFilter$="Y-Coordinate" && getWord(%brick.position,1)==%client.selectionFilterRef)
		return(true);
	else if(%client.selectionFilter$="Z-Coordinate" && getWord(%brick.position,2)==%client.selectionFilterRef)
		return(true);
	else
		return(false);
}

function SLCT_subSelection(%client,%brick,%clear)
{
	if(%client.selecting==2)
		return;
	%client.selectionLast.add(%brick);
	%client.bricksWaiting=(%client.bricksWaiting>0 ? %client.bricksWaiting-1 : %client.bricksWaiting);
	schedule(50,0,"removeFromSLCT",%client,%brick);
}

function SLCT_addSelection(%client,%brick,%clear)
{
	if(%client.selecting==2 || (getBrickGroupFromObject(%brick).Trust[%client.bl_id]!=2 && %client.bl_id!=getBrickGroupFromObject(%brick).bl_id))
		return;
	if(isObject(%client))
	{
		%brick.selected=%client;
		pruneBadSelectionBricks(%client);
	}
	else
		return;
	%client.selectionLast.add(%brick);
	%client.bricksWaiting=(%client.bricksWaiting>0 ? %client.bricksWaiting-1 : %client.bricksWaiting);
	if(isObject(%brick))
	{
		%client.SLCTGroup.add(%brick);
		%brick.oldColor=%brick.colorID SPC %brick.colorFXID SPC %brick.isRendering();
		%brick.setColor($Pref::Server::SLCTEffectColor);
		%brick.setColorFX($Pref::Server::SLCTEffectFX);
		%brick.setRendering(true);
	}
}

function manageProperties(%client,%brick,%copy)
{
	if(%copy==true)
	{
		%out=%brick.getName() SPC %brick.colorID SPC %brick.colorFXID SPC %brick.shapeFXID SPC %brick.printID SPC (isObject(%brick.emitter) ? %brick.emitter.emitter : "NONE") SPC %brick.emitterDirection SPC (isObject(%brick.Item) ? %brick.Item.getDataBlock().getName() : "NONE") SPC %brick.itemDirection SPC %brick.itemPosition SPC %brick.itemRespawnTime SPC (isObject(%brick.light) ? %brick.light.dataBlock : "NONE") SPC (isObject(%brick.vehicle) ? %brick.vehicleDataBlock SPC %brick.recolorVehicle : "NONE NONE") SPC (%brick.audioEmitter.profile.uiName!$="" ? $uiNameTable_Music[%brick.audioEmitter.profile.uiName] : "NONE");
		
		for(%x=0;%x<%brick.numEvents;%x++)
		{
			%out=%out TAB %x SPC %brick.eventDelay[%x] SPC %brick.eventEnabled[%x] SPC %brick.eventInput[%x] SPC %brick.eventInputIdx[%x] SPC %brick.eventNT[%x] SPC %brick.eventOutput[%x] SPC %brick.eventOutputAppendClient[%x] SPC %brick.eventOutputIdx[%x] SPC strReplace(%brick.eventOutputParameter[%x,1]," ","~") SPC strReplace(%brick.eventOutputParameter[%x,2]," ","~") SPC strReplace(%brick.eventOutputParameter[%x,3]," ","~") SPC strReplace(%brick.eventOutputParameter[%x,4]," ","~") SPC %brick.eventTarget[%x] SPC %brick.eventTargetIdx[%x];
		}
		
		%client.selectionCopy=%out;
		%client.centerPrint("\c3Brick " @ %brick SPC "\c2copied successfully",5);
	}
	else
	{
		%data=%client.selectionCopy;
		%count=getWordCount(getField(%data,0));
		for(%x=0;%x<%count;%x++)
		{
			%word=getWord(%data,%x);
			switch(%x)
			{
				case 0: %brick.setNTObjectName(%word);
				case 1: %brick.setColor(%word);
				case 2: %brick.setColorFX(%word);
				case 3: %brick.setShapeFX(%word);
				case 4: %brick.setPrint(%word);
				case 5: %brick.setEmitter(%word);
				case 6: %brick.setEmitterDirection(%word);
				case 7: %brick.setItem(%word);
				case 8: %brick.setItemDirection(%word);
				case 9: %brick.setItemPosition(%word);
				case 10: %brick.setItemRespawnTime(%word);
				case 11: %brick.setLight(%word);
				case 12: %brick.setVehicle(%word);
				case 13: %brick.recolorVehicle=%word;
				case 14: %brick.setMusic(%word);
				default: break;
			}
		}
		%count=getFieldCount(%data);
		%brick.clearEvents();
		for(%x=1;%x<%count;%x++)
		{
			%event=getField(%data,%x);
			%use=firstWord(%event);
			for(%i=1;%i<15;%i++)
			{
				%word=getWord(%event,%i);
				switch(%i)
				{
					case 1: %brick.eventDelay[%use]=%word;
					case 2: %brick.eventEnabled[%use]=%word;
					case 3: %brick.eventInput[%use]=%word;
					case 4: %brick.eventInputIdx[%use]=%word;
					case 5: %brick.eventNT[%use]=%word;
					case 6: %brick.eventOutput[%use]=%word;
					case 7: %brick.eventOutputAppendClient[%use]=%word;
					case 8: %brick.eventOutputIdx[%use]=%word;
					case 9: %brick.eventOutputParameter[%use,1]=strReplace(%word,"~"," ");
					case 10: %brick.eventOutputParameter[%use,2]=strReplace(%word,"~"," ");
					case 11: %brick.eventOutputParameter[%use,3]=strReplace(%word,"~"," ");
					case 12: %brick.eventOutputParameter[%use,4]=strReplace(%word,"~"," ");
					case 13: %brick.eventTarget[%use]=%word;
					case 14: %brick.eventTargetIdx[%use]=%word;
				}
			}
			%brick.numEvents++;
		}
	}
}

function forSelected(%client,%x)
{
	if(!isObject(%client.SLCTGroup) || %client.SLCTGroup.getCount()==0)
		return;
	if(%x<=0)
		return;
	pruneBadSelectionBricks(%client);
	%count=%client.SLCTGroup.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%brick=%client.SLCTGroup.getObject(%i);
		switch(%x)
		{
			case 1: //clear
				if(%client.bricksWaiting==0)
				{
					SLCT_subSelection(%client,%brick);
					%client.centerPrint("\c5Selector: \c6All bricks cleared from selection\c6.",4);
				}
			case 2: //paint
				%brick.oldColor=(%client.lastPaintType==0 ? %client.lastPaintColor : firstWord(%brick.oldColor)) SPC (%client.lastPaintType==1 ? (%client.lastPaintColor>6 ? getWord(%brick.oldColor,1) : %client.lastPaintColor) : getWord(%brick.oldColor,1)) SPC getWord(%brick.oldColor,2);
				if(%client.lastPaintType==0)
				{
					%brick.setColor(%client.lastPaintColor);
					%client.centerPrint("\c5Selector: \c6" @ %count SPC "bricks had their color changed \n\c6to the current \c2paint-can color",2);
				}
				else if(%client.lastPaintColor<7)
				{
					%brick.setColorFX(%client.lastPaintColor);
					switch(%client.lastPaintColor)
					{
						case 0: %name="None";
						case 1: %name="Pearl";
						case 2: %name="Chrome";
						case 3: %name="Glow";
						case 4: %name="Blink";
						case 5: %name="Swirl";
						case 6: %name="Rainbow";
					}
					%client.centerPrint("\c5Selector: \c6" @ %count SPC "bricks had their color changed \n\c6to the current \c3paint-can fx effect \c4(" @ %name @ ")",2);
				}
				else
				{
					if(%client.lastPaintColor>7)
					{
						%brick.setShapeFX(%client.lastPaintColor-7);
						%name=(%client.lastPaintColor==8 ? "Undulo" : "Water");
					}
					else
					{
						%brick.setShapeFX(0);
						%name="Stable";
					}
					%client.centerPrint("\c5Selector: \c6" @ %count SPC "bricks had their shape changed \n\c6to the current \c3paint-can fx effect \c4(" @ %name @ ")",2);
				}
			case 3: //kill - wand
				%trust=(getBrickGroupFromObject(%brick).Trust[%client.bl_id]==3 || %client.bl_id==getBrickGroupFromObject(%brick).bl_id);
				if(isObject(%brick) && %trust==true)
					%brick.killBrick();
				else
					%client.centerPrint((getBrickGroupFromObject(%brick).name$="" ? "\c1BL_ID: "@ getBrickGroupFromObject(%brick).bl_id : getBrickGroupFromObject(%brick).name) SPC "\c0does not trust you enough to do that.",2);
			case 4: //paste
				SLCT_subSelection(%client,%brick);
				schedule(1200,0,"manageProperties",%client,%brick,0);
			case 5: //safekill - hammer
				if(isObject(%brick))
					if(%brick.willCauseChainKill()==false)
						%brick.killBrick();
			case 6: //duplicate
				if(!isObject(%client.dupObj))
				{
					%client.dupObj = new scriptObject()
					{
						bricks = 0;
					};
				}
				if(%client.dupObj.bricks==%client.SLCTDuplicatorMaxBricks)
				{
					messageClient(%client, $Duplicator::Error[0, 8]);
					%client.dupMsg($Duplicator::Msg::MaxBricks, %client.SLCTDuplicatorMaxBricks);
					break;
				}
					%client.dupObj.brick[%client.dupObj.bricks] = %brick.getDataBlock().uiName @ "\"" SPC vectorSub(%brick.getPosition(), %client.SLCTDuplicatorStartPos) SPC %brick.getAngleId() SPC %brick.isBasePlate() SPC firstWord(%brick.oldColor) SPC %brick.getPrintName() SPC getWord(%brick.oldColor,1) SPC %brick.getShapeFxId() SPC %brick.isRayCasting() SPC %brick.isColliding() SPC getWord(%brick.oldColor,2);
				%totalData = -1;
				if(isObject(%brick.vehicleDataBlock))
					%client.dupObj.brickData[%client.dupObj.bricks, %totalData++] = "+-VEHICLE" SPC %brick.vehicleDataBlock.uiName @ "\"" SPC %brick.reColorVehicle;
				if(isObject(%brick.emitter))
					%client.dupObj.brickData[%client.dupObj.bricks, %totalData++] = "+-EMITTER" SPC %brick.emitter.emitter.uiName @ "\"" SPC %brick.emitterDirection;
				if(isObject(%brick.light))
					%client.dupObj.brickData[%client.dupObj.bricks, %totalData++] = "+-LIGHT" SPC %brick.light.dataBlock.uiName @ "\" ";
				if(isObject(%brick.item))
					%client.dupObj.brickData[%client.dupObj.bricks, %totalData++] = "+-ITEM" SPC %brick.item.dataBlock.uiName @ "\"" SPC %brick.itemPosition SPC %brick.itemDirection SPC %brick.itemRespawnTime;
				if(isObject(%brick.audioEmitter))
					%client.dupObj.brickData[%client.dupObj.bricks, %totalData++] = "+-AUDIOEMITTER" SPC %brick.audioEmitter.profile.uiName @ "\" ";
				if(%brick.getName() !$= "")
					%client.dupObj.brickData[%client.dupObj.bricks, %totalData++] = "+-NTOBJECTNAME" SPC %brick.getName();
				for(%d = 0; %d < %brick.numEvents; %d++)
				{
					%client.dupObj.brickData[%client.dupObj.bricks, %totalData++] = "+-EVENT" TAB %d TAB %brick.eventEnabled[%d] TAB %brick.eventInput[%d] TAB %brick.eventDelay[%d] TAB %brick.eventTarget[%d] TAB %brick.eventNT[%d] TAB %brick.eventOutput[%d];
					%outputClass = %brick.eventTargetIdx[%d] == -1 ? "fxDtsBrick" : inputEvent_GetTargetClass("fxDtsBrick", %brick.eventInputIdx[%d], %brick.eventTargetIdx[%d]);
					for(%e = 1; %e <= 4; %e++)
					{
						%param = %brick.eventOutputParameter[%d, %e];
						if(getWord(getField($OutputEvent_parameterList[%outputClass, %brick.eventOutputIdx[%d]], %e - 1), 0) $= "dataBlock" && isObject(%param))
							%param = %param.getName();
						%client.dupObj.brickData[%client.dupObj.bricks, %totalData] = %client.dupObj.brickData[%client.dupObj.bricks, %totalData] TAB %param;
					}
				}
				%client.dupObj.bricks++;
				%brick.dupHighlight();
		}
	}
}

function serverCmdSelector(%client,%mode,%var)
{
	if((%client.bricksWaiting>0 && %mode$="clear") || ($Pref::Server::SLCTAdminOnly==1 && %client.isAdmin==0))
		return;
	if(!isObject(%client.SLCTGroup))
		%client.SLCTGroup=new SimSet();
	pruneBadSelectionBricks(%client);
	switch$(%mode)
	{
		case "help":
			%client.chatMessage("\c5: - - - - \c6Selector Commands\c5 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -:");
			%client.chatMessage("1: \c3/selector filter <color:aaaaaa>\"keyword\"\c3:\c6   Changes filter type.");
			%client.chatMessage("2: \c3/selector size <color:aaaaaa>\"0-50\"\c3:\c6   Changes selection area size.");
			%client.chatMessage("3: \c3/selector tools:\c6   Allows use of tools on selected bricks.");
			%client.chatMessage("4: \c3/selector copy:\c6   Switches to the Copy selection mode.");
			%client.chatMessage("5: \c3/selector paste:\c6   Applies copied brick settings to selected bricks.");
		case "cancel":
			if(%var==0)
			{
				%client.selecting=2;
				schedule(((%client.bricksWaiting/(%client.isAdmin==0 ? $Pref::Server::SLCTWaitTime : $Pref::Server::SLCTWaitTime::Admin))*(%client.bricksWaiting/10)),0,"serverCmdSelector",%client,"cancel",1);
			}
			else
			{
				SLCTGroup_clear(%client.SLCTGroup);
				%client.bricksWaiting=0;
			}
		case "clear":
			forSelected(%client,1);
		case "tools":
			if(%client.selectorTools==false && %client.SLCTGroup.getCount()>0)
			{
				%client.selectorTools=true;
				%client.player.mountImage("hammerImage",0,true,"NULL");
			}
		case "copy":
			%client.centerPrint("\c5Selector\c6 changed to\c3 Copy \c6mode; select a brick to copy properties from.",4);
			%client.selectMode=2;
		case "paste":
			forSelected(%client,4);
		case "size":
			%use=stripChars(%var,"qwertyuiop[]\\asdfghjkl;'zxcvbnm,./{}|:<>?\"+_-=)(*&^%$#@!");
			if(%use>50 || %use<0 || %use$="")
				%use=0;
			%client.selectSize=%use;
			%client.centerPrint("\c6Selection size set to \c3" @ %use,3);
		case "filter":
			if(%var$="")
			{
				switch$(%client.selectionFilter)
				{
					case "Color": %property="Ownership";
					case "Ownership": %property="Brick-Type";
					case "Brick-Type": %property="Print";
					case "Print": %property="Wrench-Settings";
					case "Wrench-Settings": %property="X-Coordinate";
					case "X-Coordinate": %property="Y-Coordinate";
					case "Y-Coordinate": %property="Z-Coordinate";
					case "Z-Coordinate": %property="None";
					default: %property="Color";
				}
			}
			else
			{
				switch$(%var)
				{
					case "color": %property="Color";
					case "ownership": %property="Ownership";
					case "owner": %property="Ownership";
					case "BL_ID": %property="Ownership";
					case "BLID": %property="Ownership";
					case "ID": %property="Ownership";
					case "brick-type": %property="Brick-Type";
					case "brick": %property="Brick-Type";
					case "type": %property="Brick-Type";
					case "brick-type": %property="Brick-Type";
					case "datablock": %property="Brick-Type";
					case "print": %property="Print";
					case "printer": %property="Print";
					case "printID": %property="Print";
					case "decal": %property="Print";
					case "wrench-settings": %property="Wrench-Settings";
					case "wrench": %property="Wrench-Settings";
					case "settings": %property="Wrench-Settings";
					case "X-Coordinate": %property="X-Coordinate";
					case "X": %property="X-Coordinate";
					case "Y-Coordinate": %property="Y-Coordinate";
					case "Y": %property="Y-Coordinate";
					case "Z-Coordinate": %property="Z-Coordinate";
					case "Z": %property="Z-Coordinate";
					default:
						%property="None";
				}
			}
			%client.selectionFilter=%property;
			%client.centerPrint((%client.selectionFilter$="None" ? "\c6Selection will include \c2all bricks\c6." : "\c6Selection \c0will not\c6 include bricks not matching target brick \c3" @ %property @ "\c6."),4);
		default:
			if(%var$="~")
			{
				%client.selectorTools=0;
				%client.bottomPrint(" ",0.01);
				return;
			}
			if(isObject(%client.player.getMountedImage(0)))
				if(%client.player.getMountedImage(0).getName()$="selectorImage")
					serverCmdSelector(%client,"help",0);
			%client.player.mountImage("selectorImage",0,true,"NULL");
	}
}